diff -crN nakedmudv1.4/src/body.c nakedmudv1.5/src/body.c
*** nakedmudv1.4/src/body.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/body.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 57,67 ****
    "held"
  };
  
- const char *bodytype_list[NUM_BODYTYPES] = {
-   "humanoid",
-   "dragon",
- };
- 
  const char *bodysize_list[NUM_BODYSIZES] = {
    "diminuitive",
    "tiny",
--- 57,62 ----
***************
*** 108,173 ****
    return p_new;
  }
  
- /**
-  * Create a new body with dragon pieces and proportions
-  */
- BODY_DATA *newDragonBody() {
-   BODY_DATA *body = newBody();
-   body->size = BODYSIZE_COLLOSAL;
-   bodyAddPosition(body, "left hind claw",          BODYPOS_CLAW,          1);
-   bodyAddPosition(body, "right hind claw",         BODYPOS_CLAW,          1);
-   bodyAddPosition(body, "left front claw",         BODYPOS_CLAW,          1);
-   bodyAddPosition(body, "right front claw",        BODYPOS_CLAW,          1);
-   bodyAddPosition(body, "right hind leg",          BODYPOS_LEG,           8);
-   bodyAddPosition(body, "left hind leg",           BODYPOS_LEG,           8);
-   bodyAddPosition(body, "right front leg",         BODYPOS_LEG,           8);
-   bodyAddPosition(body, "left front leg",          BODYPOS_LEG,           8);
-   bodyAddPosition(body, "left wing",               BODYPOS_WING,         10);
-   bodyAddPosition(body, "right wing",              BODYPOS_WING,         10);
-   bodyAddPosition(body, "torso",                   BODYPOS_TORSO,        30);
-   bodyAddPosition(body, "neck",                    BODYPOS_NECK,          3);
-   bodyAddPosition(body, "face",                    BODYPOS_FACE,          3);
-   bodyAddPosition(body, "head",                    BODYPOS_HEAD,          2);
-   bodyAddPosition(body, "tail",                    BODYPOS_TAIL,          6);
-   bodyAddPosition(body, "floating about head",     BODYPOS_FLOAT,         0);
-   //                                                                  ------
-   //                                                                    100
-   return body;
- }
- 
- /**
-  * Create a new body with humanoid pieces and proportions
-  */
- BODY_DATA *newHumanoidBody() {
-   BODY_DATA *body = newBody();
-   body->size = BODYSIZE_MEDIUM;
-   bodyAddPosition(body, "right grip",              BODYPOS_HELD,          0);
-   bodyAddPosition(body, "left grip",               BODYPOS_HELD,          0);
-   bodyAddPosition(body, "right foot",              BODYPOS_RIGHT_FOOT,    2);
-   bodyAddPosition(body, "left foot",               BODYPOS_LEFT_FOOT,     2);
-   bodyAddPosition(body, "right leg",               BODYPOS_LEG,           9);
-   bodyAddPosition(body, "left leg",                BODYPOS_LEG,           9);
-   bodyAddPosition(body, "waist",                   BODYPOS_WAIST,         1);
-   bodyAddPosition(body, "right finger",            BODYPOS_FINGER,        1);
-   bodyAddPosition(body, "left finger",             BODYPOS_FINGER,        1);
-   bodyAddPosition(body, "right hand",              BODYPOS_RIGHT_HAND,    2);
-   bodyAddPosition(body, "left hand",               BODYPOS_LEFT_HAND,     2);
-   bodyAddPosition(body, "right wrist",             BODYPOS_WRIST,         1);
-   bodyAddPosition(body, "left wrist",              BODYPOS_WRIST,         1);
-   bodyAddPosition(body, "right arm",               BODYPOS_ARM,           7);
-   bodyAddPosition(body, "left arm",                BODYPOS_ARM,           7);
-   bodyAddPosition(body, "about body",              BODYPOS_ABOUT,         0);
-   bodyAddPosition(body, "torso",                   BODYPOS_TORSO,        50);
-   bodyAddPosition(body, "neck",                    BODYPOS_NECK,          1);
-   bodyAddPosition(body, "right ear",               BODYPOS_EAR,           0);
-   bodyAddPosition(body, "left ear",                BODYPOS_EAR,           0);
-   bodyAddPosition(body, "face",                    BODYPOS_FACE,          2);
-   bodyAddPosition(body, "head",                    BODYPOS_HEAD,          2);
-   bodyAddPosition(body, "floating about head",     BODYPOS_FLOAT,         0);
-   //                                                                  ------
-   //                                                                    100
-   return body;
- }
  
  
  //*****************************************************************************
--- 103,108 ----
***************
*** 196,213 ****
    return strdup(types);
  }
  
- const char *bodytypeGetName(int bodytype) {
-   return bodytype_list[bodytype];
- }
- 
- int bodytypeGetNum(const char *bodytype) {
-   int i;
-   for(i = 0; i < NUM_BODYTYPES; i++)
-     if(!strcasecmp(bodytype, bodytype_list[i]))
-       return i;
-   return BODYTYPE_NONE;
- }
- 
  const char *bodysizeGetName(int size) {
    return bodysize_list[size];
  }
--- 131,136 ----
***************
*** 232,246 ****
    return BODYPOS_NONE;
  }
  
- BODY_DATA *bodyCreate(int bodytype) {
-   switch(bodytype) {
-   case BODYTYPE_HUMANOID:  return newHumanoidBody();
-   case BODYTYPE_DRAGON:    return newDragonBody();
-   default:                 return NULL;
-   }
- }
- 
- 
  BODY_DATA *newBody() {
    struct body_data*B = malloc(sizeof(BODY_DATA));
    B->parts = newList();
--- 155,160 ----
***************
*** 268,273 ****
--- 182,191 ----
    return B->size;
  }
  
+ void bodySetSize(BODY_DATA *B, int size) {
+   B->size = size;
+ }
+ 
  //
  // Find a bodypart on the body with the given name
  //
diff -crN nakedmudv1.4/src/body.h nakedmudv1.5/src/body.h
*** nakedmudv1.4/src/body.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/body.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 38,49 ****
  
  #define NUM_BODYPOS              21
  
- #define BODYTYPE_NONE            -1
- #define BODYTYPE_HUMANOID         0
- #define BODYTYPE_DRAGON           1
- 
- #define NUM_BODYTYPES             2
- 
  #define BODYSIZE_NONE            -1
  #define BODYSIZE_DIMINUITIVE      0
  #define BODYSIZE_TINY             1
--- 38,43 ----
***************
*** 62,79 ****
  
  
  /**
-  * return the name of the bodytype number
-  */
- const char *bodytypeGetName(int bodytype);
- 
- 
- /**
-  * return the number of the bodytype
-  */
- int bodytypeGetNum(const char *bodytype);
- 
- 
- /**
   * return the name of the body position type 
   */
  const char *bodyposGetName(int bodypos);
--- 56,61 ----
***************
*** 98,109 ****
  
  
  /**
-  * Create a specific bodytype
-  */
- BODY_DATA *bodyCreate(int bodytype);
- 
- 
- /**
   * Create a new body
   */
  BODY_DATA *newBody();
--- 80,85 ----
***************
*** 127,132 ****
--- 103,112 ----
   */
  int bodyGetSize(const BODY_DATA *B);
  
+ /**
+  * change the body's size
+  */
+ void bodySetSize(BODY_DATA *B, int size);
  
  /**
   * Add a new position to the body. <type> is one of the basic
diff -crN nakedmudv1.4/src/character.c nakedmudv1.5/src/character.c
*** nakedmudv1.4/src/character.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/character.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 93,104 ****
    char                 * password;
    bitvector_t            prfs;  
    room_vnum              loadroom;
  
    // shared data for PCs and NPCs
    int                    uid;
  
    BODY_DATA            * body;
!   int                    race;
  
    SOCKET_DATA          * socket;
    ROOM_DATA            * room;
--- 93,106 ----
    char                 * password;
    bitvector_t            prfs;  
    room_vnum              loadroom;
+   int                    imm_invis;
  
    // shared data for PCs and NPCs
    int                    uid;
  
    BODY_DATA            * body;
!   char                 * race;
!   //  int                    race;
  
    SOCKET_DATA          * socket;
    ROOM_DATA            * room;
***************
*** 128,138 ****
  
    ch->password      = strdup("");
    ch->prfs          = 0;
  
    ch->loadroom      = NOWHERE;
    ch->uid           = NOBODY;
  
!   ch->race          = RACE_HUMAN;
    ch->body          = raceCreateBody(ch->race);
    ch->room          = NULL;
    ch->furniture     = NULL;
--- 130,141 ----
  
    ch->password      = strdup("");
    ch->prfs          = 0;
+   ch->imm_invis     = 0;
  
    ch->loadroom      = NOWHERE;
    ch->uid           = NOBODY;
  
!   ch->race          = strdup(raceDefault());//RACE_HUMAN;
    ch->body          = raceCreateBody(ch->race);
    ch->room          = NULL;
    ch->furniture     = NULL;
***************
*** 281,287 ****
    return ch->body;
  }
  
! int          charGetRace  ( CHAR_DATA *ch) {
    return ch->race;
  }
  
--- 284,290 ----
    return ch->body;
  }
  
! const char  *charGetRace  ( CHAR_DATA *ch) {
    return ch->race;
  }
  
***************
*** 301,306 ****
--- 304,313 ----
    return ch->furniture;
  }
  
+ int charGetImmInvis(CHAR_DATA *ch) {
+   return ch->imm_invis;
+ }
+ 
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket) {
    ch->socket = socket;
  };
***************
*** 344,351 ****
    ch->body = body;
  }
  
! void         charSetRace  (CHAR_DATA *ch, int race) {
!   ch->race = race;
  }
  
  void         charSetUID(CHAR_DATA *ch, int uid) {
--- 351,359 ----
    ch->body = body;
  }
  
! void         charSetRace  (CHAR_DATA *ch, const char *race) {
!   if(ch->race) free(ch->race);
!   ch->race = strdup(race);
  }
  
  void         charSetUID(CHAR_DATA *ch, int uid) {
***************
*** 364,369 ****
--- 372,380 ----
    ch->furniture = furniture;
  }
  
+ void charSetImmInvis(CHAR_DATA *ch, int level) {
+   ch->imm_invis = level;
+ }
  
  
  //*****************************************************************************
***************
*** 401,420 ****
  CHAR_DATA *charRead(STORAGE_SET *set) {
    CHAR_DATA *mob = newMobile();
  
!   charSetVnum(mob,          read_int   (set, "vnum"));
    charSetName(mob,         read_string(set, "name"));
!   charSetKeywords(mob,      read_string(set, "keywords"));
    charSetRdesc(mob,        read_string(set, "rdesc"));
    charSetDesc(mob,         read_string(set, "desc"));
    charSetMultiRdesc(mob,   read_string(set, "multirdesc"));
    charSetMultiName(mob,    read_string(set, "multiname"));
    charSetLevel(mob,        read_int   (set, "level"));
    charSetSex(mob,          read_int   (set, "sex"));
!   charSetRace(mob,         read_int   (set, "race"));
    charSetPassword(mob,     read_string(set, "password"));
  
    // read in PC data
    if(*charGetPassword(mob)) {
      charSetUID(mob,        read_int   (set, "uid"));
      charSetLoadroom(mob,   read_int   (set, "loadroom"));
      charSetPos(mob,        read_int   (set, "position"));
--- 412,432 ----
  CHAR_DATA *charRead(STORAGE_SET *set) {
    CHAR_DATA *mob = newMobile();
  
!   charSetVnum(mob,         read_int   (set, "vnum"));
    charSetName(mob,         read_string(set, "name"));
!   charSetKeywords(mob,     read_string(set, "keywords"));
    charSetRdesc(mob,        read_string(set, "rdesc"));
    charSetDesc(mob,         read_string(set, "desc"));
    charSetMultiRdesc(mob,   read_string(set, "multirdesc"));
    charSetMultiName(mob,    read_string(set, "multiname"));
    charSetLevel(mob,        read_int   (set, "level"));
    charSetSex(mob,          read_int   (set, "sex"));
!   charSetRace(mob,         read_string(set, "race"));
    charSetPassword(mob,     read_string(set, "password"));
  
    // read in PC data
    if(*charGetPassword(mob)) {
+     charSetImmInvis(mob,   read_int   (set, "imm_invis"));
      charSetUID(mob,        read_int   (set, "uid"));
      charSetLoadroom(mob,   read_int   (set, "loadroom"));
      charSetPos(mob,        read_int   (set, "position"));
***************
*** 428,433 ****
--- 440,451 ----
    mob->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
  					  AUXILIARY_TYPE_CHAR);
  
+   // make sure our race is OK
+   if(!isRace(mob->race)) {
+     free(mob->race);
+     mob->race = strdup(raceDefault());
+   }
+ 
    // reset our body to the default for our race
    charResetBody(mob);
  
***************
*** 437,466 ****
  
  STORAGE_SET *charStore(CHAR_DATA *mob) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum",       mob->vnum,                 NULL);
!   store_string(set, "name",       mob->name,                 NULL);
!   store_string(set, "keywords",   mob->keywords,             NULL);
!   store_string(set, "rdesc",      mob->rdesc,                NULL);
!   store_string(set, "desc",       mob->desc,                 NULL);
!   store_string(set, "multirdesc", mob->multi_rdesc,          NULL);
!   store_string(set, "multiname",  mob->multi_name,           NULL);
!   store_int   (set, "level",      mob->level,                NULL);
!   store_int   (set, "sex",        mob->sex,                  NULL);
!   store_int   (set, "race",       mob->race,                 NULL);
  
    // PC-only data
    if(!charIsNPC(mob)) {
!     store_int   (set, "position",   mob->position,                 NULL);
!     store_string(set, "prfs",       write_bits(mob->prfs),         NULL);
!     store_string(set, "password",   mob->password,                 NULL);
!     store_int   (set, "uid",        mob->uid,                      NULL);
!     store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)), NULL);
    }
    // NPC-only data
    else
!     store_int   (set, "dialog",     mob->dialog,               NULL);
  
!   store_set(set,"auxiliary", auxiliaryDataStore(mob->auxiliary_data), NULL);
    return set;
  }
  
--- 455,485 ----
  
  STORAGE_SET *charStore(CHAR_DATA *mob) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum",       mob->vnum);
!   store_string(set, "name",       mob->name);
!   store_string(set, "keywords",   mob->keywords);
!   store_string(set, "rdesc",      mob->rdesc);
!   store_string(set, "desc",       mob->desc);
!   store_string(set, "multirdesc", mob->multi_rdesc);
!   store_string(set, "multiname",  mob->multi_name);
!   store_int   (set, "level",      mob->level);
!   store_int   (set, "sex",        mob->sex);
!   store_string(set, "race",       mob->race);
  
    // PC-only data
    if(!charIsNPC(mob)) {
!     store_int   (set, "imm_invis",  mob->imm_invis);
!     store_int   (set, "position",   mob->position);
!     store_string(set, "prfs",       write_bits(mob->prfs));
!     store_string(set, "password",   mob->password);
!     store_int   (set, "uid",        mob->uid);
!     store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)));
    }
    // NPC-only data
    else
!     store_int   (set, "dialog",     mob->dialog);
  
!   store_set(set,"auxiliary", auxiliaryDataStore(mob->auxiliary_data));
    return set;
  }
  
***************
*** 480,485 ****
--- 499,505 ----
    charSetPos        (to, charGetPos(from));
    charSetRace       (to, charGetRace(from));
    charSetBody       (to, bodyCopy(charGetBody(from)));
+   charSetImmInvis   (to, charGetImmInvis(from));
  
    auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
  }
diff -crN nakedmudv1.4/src/character.h nakedmudv1.5/src/character.h
*** nakedmudv1.4/src/character.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/character.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 36,41 ****
--- 36,42 ----
  void         charResetBody    (CHAR_DATA *ch);
  
  
+ 
  //*****************************************************************************
  //
  // utility functions
***************
*** 70,81 ****
  char       **charGetDescPtr   ( CHAR_DATA *ch);
  LIST        *charGetInventory ( CHAR_DATA *ch);
  BODY_DATA   *charGetBody      ( CHAR_DATA *ch);
! int          charGetRace      ( CHAR_DATA *ch);
  int          charGetUID       ( CHAR_DATA *ch);
  room_vnum    charGetLoadroom  ( CHAR_DATA *ch);
  OBJ_DATA    *charGetFurniture ( CHAR_DATA *ch);
  int          charGetPos       ( CHAR_DATA *ch);
  void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
  
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket);
  void         charSetRoom      ( CHAR_DATA *ch, ROOM_DATA *room);
--- 71,83 ----
  char       **charGetDescPtr   ( CHAR_DATA *ch);
  LIST        *charGetInventory ( CHAR_DATA *ch);
  BODY_DATA   *charGetBody      ( CHAR_DATA *ch);
! const char  *charGetRace      ( CHAR_DATA *ch);
  int          charGetUID       ( CHAR_DATA *ch);
  room_vnum    charGetLoadroom  ( CHAR_DATA *ch);
  OBJ_DATA    *charGetFurniture ( CHAR_DATA *ch);
  int          charGetPos       ( CHAR_DATA *ch);
  void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
+ int          charGetImmInvis  ( CHAR_DATA *ch);
  
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket);
  void         charSetRoom      ( CHAR_DATA *ch, ROOM_DATA *room);
***************
*** 88,98 ****
  void         charSetMultiRdesc( CHAR_DATA *ch, const char *multi_rdesc);
  void         charSetMultiName ( CHAR_DATA *ch, const char *multi_name);
  void         charSetBody      ( CHAR_DATA *ch, BODY_DATA *body);
! void         charSetRace      ( CHAR_DATA *ch, int race);
  void         charSetUID       ( CHAR_DATA *ch, int uid);
  void         charSetLoadroom  ( CHAR_DATA *ch, room_vnum loadroom);
  void         charSetFurniture ( CHAR_DATA *ch, OBJ_DATA *furniture);
  void         charSetPos       ( CHAR_DATA *ch, int pos);
  
  
  //*****************************************************************************
--- 90,102 ----
  void         charSetMultiRdesc( CHAR_DATA *ch, const char *multi_rdesc);
  void         charSetMultiName ( CHAR_DATA *ch, const char *multi_name);
  void         charSetBody      ( CHAR_DATA *ch, BODY_DATA *body);
! void         charSetRace      ( CHAR_DATA *ch, const char *race);
  void         charSetUID       ( CHAR_DATA *ch, int uid);
  void         charSetLoadroom  ( CHAR_DATA *ch, room_vnum loadroom);
  void         charSetFurniture ( CHAR_DATA *ch, OBJ_DATA *furniture);
  void         charSetPos       ( CHAR_DATA *ch, int pos);
+ void         charSetImmInvis  ( CHAR_DATA *ch, int level);
+ 
  
  
  //*****************************************************************************
***************
*** 120,128 ****
--- 124,135 ----
  void         charRemoveBit    ( CHAR_DATA *ch, int field, int bit);
  bool         charIsBitSet     ( CHAR_DATA *ch, int field, int bit);
  
+ // hmmm... we should really replace bitvectors with something a bit
+ // more amenable to extention by modules. Perhaps use char_vars?
  #define BITFIELD_PRFS             0
  
  #define PRF_BUILDWALK             0    // (1 << 0)
+ #define PRF_MAPWALK               1    // (1 << 1)
  
  
  
***************
*** 132,140 ****
  //
  //*****************************************************************************
  #define SEX_NONE                (-1)
! #define SEX_NEUTRAL               0
! #define SEX_MALE                  1
! #define SEX_FEMALE                2
  #define NUM_SEXES                 3
  
  const char *sexGetName(int sex);
--- 139,147 ----
  //
  //*****************************************************************************
  #define SEX_NONE                (-1)
! #define SEX_MALE                  0
! #define SEX_FEMALE                1
! #define SEX_NEUTRAL               2
  #define NUM_SEXES                 3
  
  const char *sexGetName(int sex);
diff -crN nakedmudv1.4/src/char_vars/char_vars.c nakedmudv1.5/src/char_vars/char_vars.c
*** nakedmudv1.4/src/char_vars/char_vars.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/char_vars/char_vars.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 179,191 ****
    const char        *key = NULL;
    CHAR_VAR          *val = NULL;
  
!   store_list(set, "variables", list, NULL);
    // iterate across all the entries and add them
    ITERATE_HASH(key, val, hash_i) {
      STORAGE_SET *var_set = new_storage_set();
!     store_string(var_set, "key",  key,                       NULL);
!     store_string(var_set, "val",  val->str_val,              NULL);
!     store_string(var_set, "type", char_var_types[val->type], NULL);
      storage_list_put(list, var_set);
    }
    deleteHashIterator(hash_i);
--- 179,191 ----
    const char        *key = NULL;
    CHAR_VAR          *val = NULL;
  
!   store_list(set, "variables", list);
    // iterate across all the entries and add them
    ITERATE_HASH(key, val, hash_i) {
      STORAGE_SET *var_set = new_storage_set();
!     store_string(var_set, "key",  key);
!     store_string(var_set, "val",  val->str_val);
!     store_string(var_set, "type", char_var_types[val->type]);
      storage_list_put(list, var_set);
    }
    deleteHashIterator(hash_i);
diff -crN nakedmudv1.4/src/cmd_admin.c nakedmudv1.5/src/cmd_admin.c
*** nakedmudv1.4/src/cmd_admin.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/cmd_admin.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,252 ----
+ //*****************************************************************************
+ //
+ // cmd_admin.c
+ //
+ // commands and procedures available only to admins.
+ //
+ //*****************************************************************************
+ 
+ #include "mud.h"
+ #include "world.h"
+ #include "inform.h"
+ #include "character.h"
+ #include "handler.h"
+ #include "utils.h"
+ #include "log.h"
+ #include "socket.h"
+ #include "save.h"
+ #include "event.h"
+ #include "action.h"
+ #include "storage.h"
+ 
+ 
+ //
+ // BOOM! Shut down the MUD
+ //
+ COMMAND(cmd_shutdown) {
+   shut_down = TRUE;
+ }
+ 
+ 
+ //
+ // Go to a specific room, object, or character in the game. Rooms are referenced
+ // by vnum. Everything else is referenced by name.
+ //   usage: goto [thing]
+ //
+ //   examples:
+ //     goto 100             go to room number 100
+ //     goto jim             go to an object/person named jim
+ //
+ COMMAND(cmd_goto) {
+   if(!arg || !*arg)
+     send_to_char(ch, "Where would you like to go to?\r\n");
+   // we're trying to go to a specific room number
+   else if(isdigit(*arg)) {
+     ROOM_DATA *room = worldGetRoom(gameworld, atoi(arg));
+ 
+     if(!room)
+       send_to_char(ch, "No such room exists.\r\n");
+     else if(room == charGetRoom(ch))
+       send_to_char(ch, "You're already here, boss.\r\n");
+     else {
+       message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	      "$n disappears in a puff of smoke.");
+       char_from_room(ch);
+       char_to_room(ch, room);
+       look_at_room(ch, room);
+       message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	      "$n arrives in a puff of smoke.");
+     }
+   }
+ 
+   // find the character we're trying to go to
+   else {
+     void *tgt = generic_find(ch, arg, 
+ 			     FIND_TYPE_CHAR,
+ 			     FIND_SCOPE_WORLD | FIND_SCOPE_VISIBLE,
+ 			     FALSE, NULL);
+ 
+     if(ch == tgt)
+       send_to_char(ch, "You're already here, boss.\r\n");
+     else if(tgt != NULL) {
+       message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	      "$n disappears in a puff of smoke.");
+       char_from_room(ch);
+       char_to_room(ch, charGetRoom(tgt));
+       look_at_room(ch, charGetRoom(ch));
+       message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	      "$n arrives in a puff of smoke.");
+     }
+     else
+       send_to_char(ch, "Who were you trying to go to?\r\n");
+   }
+ }
+ 
+ 
+ //
+ // The opposite of goto. Instead of moving to a specified location, it
+ // takes the target to the user.
+ //   usage: transfer [player]
+ //
+ COMMAND(cmd_transfer) {
+   if(!arg || !*arg)
+     send_to_char(ch, "Who would you like to transfer?\r\n");
+   else {
+     void *tgt = generic_find(ch, arg, 
+ 			     FIND_TYPE_CHAR,
+ 			     FIND_SCOPE_WORLD | FIND_SCOPE_VISIBLE,
+ 			     FALSE, NULL);
+ 
+     if(ch == tgt)
+       send_to_char(ch, "You're already here, boss.\r\n");
+     else if(charGetRoom(ch) == charGetRoom(tgt))
+       send_to_char(ch, "They're already here.\r\n");
+     else if(tgt != NULL) {
+       message(ch, tgt, NULL, NULL, TRUE, TO_VICT,
+ 	      "$n has transferred you!");
+       message(tgt, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	      "$n disappears in a puff of smoke.");
+       char_from_room(tgt);
+       char_to_room(tgt, charGetRoom(ch));
+       look_at_room(tgt, charGetRoom(tgt));
+       message(tgt, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	      "$n arrives in a puff of smoke.");
+     }
+     else
+       send_to_char(ch, "Who were you trying to transfer?\r\n");
+   }
+ }
+ 
+ 
+ //
+ // Perform a copyover
+ //
+ COMMAND(cmd_copyover) { 
+   FILE *fp;
+   SOCKET_DATA *dsock;
+   char buf[100];
+   char control_buf[20];
+   char port_buf[20];
+   LIST_ITERATOR *sock_i = newListIterator(socket_list);
+   
+   if ((fp = fopen(COPYOVER_FILE, "w")) == NULL)
+   {
+     text_to_char(ch, "Copyover file not writeable, aborted.\n\r");
+     return;
+   }
+ 
+   sprintf(buf, "\n\r <*>            The world starts spinning             <*>\n\r");
+ 
+   /* For each playing descriptor, save its state */
+   //  for (dsock = dsock_list; dsock ; dsock = dsock_next)
+   ITERATE_LIST(dsock, sock_i) {
+     compressEnd(dsock, dsock->compressing, FALSE);
+     if (dsock->state != STATE_PLAYING) {
+       text_to_socket(dsock, "\r\nSorry, we are rebooting. Come back in a few minutes.\r\n");
+       close_socket(dsock, FALSE);
+     }
+     else {
+       fprintf(fp, "%d %s %s\n",
+ 	      dsock->control, charGetName(dsock->player), dsock->hostname);
+       /* save the player */
+       save_player(dsock->player);
+       text_to_socket(dsock, buf);
+     }
+   }
+   deleteListIterator(sock_i);
+   
+   fprintf (fp, "-1\n");
+   fclose (fp);
+ 
+ 
+   /* close any pending sockets */
+   recycle_sockets();
+   
+   /* exec - descriptors are inherited */
+   sprintf(control_buf, "%d", control);
+   sprintf(port_buf, "%d", mudport);
+   execl(EXE_FILE, "NakedMud", "-copyover", control_buf, port_buf, NULL);
+ 
+   /* Failed - sucessful exec will not return */
+   text_to_char(ch, "Copyover FAILED!\n\r");
+ }
+ 
+ 
+ //
+ // show a list of all the PCs who are linkdead
+ //
+ COMMAND(cmd_linkdead) {
+   CHAR_DATA *xMob;
+   char buf[MAX_BUFFER];
+   bool found = FALSE;
+   LIST_ITERATOR *mob_i = newListIterator(mobile_list);
+ 
+   ITERATE_LIST(xMob, mob_i) {
+     if (!(charIsNPC(xMob) || charGetSocket(xMob))) {
+       sprintf(buf, "%s is linkdead.\n\r", charGetName(xMob));
+       text_to_char(ch, buf);
+       found = TRUE;
+     }
+   }
+   deleteListIterator(mob_i);
+ 
+   if (!found)
+     text_to_char(ch, "Noone is currently linkdead.\n\r");
+ }
+ 
+ 
+ //
+ // List all of the non-player commands the character has access to
+ //
+ COMMAND(cmd_wizhelp) {
+   show_commands(ch, LEVEL_BUILDER, charGetLevel(ch));
+ }
+ 
+ 
+ //
+ // Turn on/off immortal invisibility
+ //
+ COMMAND(cmd_invis) {
+   int level = charGetLevel(ch); // default to our level
+   if(arg && *arg && isdigit(*arg))
+     level = atoi(arg);
+ 
+   // make sure we're not trying to go invisible at a level higher than us
+   if(level > charGetLevel(ch)) {
+     send_to_char(ch, "You cannot go invisibile to a level higher than yours.\r\n");
+     return;
+   }
+ 
+   // see if we're trying to go visible
+   if(level == 0 && charGetImmInvis(ch) > 0) {
+     send_to_char(ch, "Invisibility turned off.\r\n");
+     charSetImmInvis(ch, 0);
+     message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	    "$n slowly fades into existence.");    
+   }
+   // or invisible
+   else if(level > 0) {
+     message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	    "$n slowly fades out of existence.");
+     charSetImmInvis(ch, level);
+     send_to_char(ch, "You are now invisible to anyone below level %d.\r\n",
+ 		 level);
+   }
+   // we tried to go visible, but we already are visible
+   else
+     send_to_char(ch, "But you're already visible!\r\n");
+ }
+ 
+ 
+ //
+ // turn off immortal invisibility
+ //
+ COMMAND(cmd_visible) {
+   if(charGetImmInvis(ch) == 0)
+     send_to_char(ch, "But you're already visible!\r\n");
+   else {
+     charSetImmInvis(ch, 0);
+     message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	    "$n slowly fades into existence.");
+   }
+ }
